package DVDPro2Sage;
import java.io.*;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;


import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.*;

import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;

import javax.xml.transform.dom.DOMSource;
  
import javax.xml.transform.stream.StreamResult;

/*
 * Created on May 29, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author Chad
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class DVDPro2Sage {
	
	static Document document;
	static NodeList DVDs;
	private static final int MAX_ELEMENTS = 100;
	private static final String DVDP_PATH = "C:\\Program Files\\Intervocative Software\\DVD Profiler\\IMAGES\\";
	private Vector titles = new Vector();
	private Vector safeTitles = new Vector();
	private int numTitles = 0;
	
	public DVDPro2Sage(String f){
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;
		try {
			builder = factory.newDocumentBuilder();
			document = builder.parse(new File(f));
		} catch (ParserConfigurationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SAXException sxe) {
			// TODO Auto-generated catch block
			sxe.printStackTrace();
		} catch (IOException ioe) {
			// TODO Auto-generated catch block
			ioe.printStackTrace();
		}
		document.normalize();
		DVDs = document.getElementsByTagName("DVD");
		
		numTitles = getNumCollection();
		//Make a title list to make searches quicker
		for(int i = 0; i < numTitles; i++)
		{
			titles.add(getTitle(i));
			safeTitles.add(getSafeTitle(i));
		}
		
	}
	
	public void writeDVD(int i, String name)
	{
		Node node = DVDs.item(i);
		File out = new File(name);
		try {
		   // Use a Transformer for output
		   TransformerFactory tFactory = TransformerFactory.newInstance();
		   Transformer transformer = tFactory.newTransformer();
		   DOMSource source = new DOMSource(node);
		   StreamResult result = new StreamResult(out);
		   transformer.transform(source, result);
		   
		   
		} catch (TransformerConfigurationException tce) {
		   // Error generated by the parser
		   System.out.println ("\n** Transformer Factory error");
		   System.out.println("   " + tce.getMessage() );

		   // Use the contained exception, if any
		   Throwable x = tce;
		   if (tce.getException() != null)
		       x = tce.getException();
		   x.printStackTrace();
		      
		} catch (TransformerException te) {
		   // Error generated by the parser
		   System.out.println ("\n** Transformation error");
		   System.out.println("   " + te.getMessage() );

		   // Use the contained exception, if any
		   Throwable x = te;
		   if (te.getException() != null)
		       x = te.getException();
		   x.printStackTrace();
		}
		
		
	}
	
	public void printDVD(Node node)
	{
//		Node node = DVDs.item(i);
		try {
		   // Use a Transformer for output
		   TransformerFactory tFactory = TransformerFactory.newInstance();
		   Transformer transformer = tFactory.newTransformer();
		   DOMSource source = new DOMSource((Node) node);
		   StreamResult result = new StreamResult(System.out);
		   transformer.transform(source, result);

		   
		} catch (TransformerConfigurationException tce) {
		   // Error generated by the parser
		   System.out.println ("\n** Transformer Factory error");
		   System.out.println("   " + tce.getMessage() );

		   // Use the contained exception, if any
		   Throwable x = tce;
		   if (tce.getException() != null)
		       x = tce.getException();
		   x.printStackTrace();
		      
		} catch (TransformerException te) {
		   // Error generated by the parser
		   System.out.println ("\n** Transformation error");
		   System.out.println("   " + te.getMessage() );

		   // Use the contained exception, if any
		   Throwable x = te;
		   if (te.getException() != null)
		       x = te.getException();
		   x.printStackTrace();
		}
		
		
	}
	
	public void writeAllDVDs(String path, boolean copy)
	{
		
		if(!path.endsWith("\\"))
		{
			path = path+"\\";
		}
		for(int i = 0; i < numTitles; i++)
		{	
			File dir = new File(path+getSafeTitle(i));
			dir.mkdirs();
			writeDVD(i, path+getSafeTitle(i)+"\\"+getSafeTitle(i)+".xml");
//			Copy the images
			if(copy)
			{
				try {
					copyImage(DVDP_PATH+getID(i)+"f.jpg", path+getSafeTitle(i)+"\\front.jpg");
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				try {
					copyImage(DVDP_PATH+getID(i)+"b.jpg", path+getSafeTitle(i)+"\\back.jpg");
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
		}
	}

	public int findDVD(String name)
	{
//		boolean found = false;
//		int number = -1;
//		for(int i = 0; i < numTitles && !found; i++)
//		{
//			if(getTitle(i).indexOf(name) > -1 || getSafeTitle(i).indexOf(name) > -1)
//			{
////				System.out.println("findDVD"+getTitle(i));
//				found = true;
//				number = i;
//			}
//			
//		}
		
		int index = titles.indexOf(name);
		if(index == -1)
		{
			name = name.toLowerCase();
			index = safeTitles.indexOf(name);
		}
			
		
		return index;
		//return number;
	}
	
	
	public int getNumCollection() {
		return DVDs.getLength();
	}
	
	public String  getID(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Property = node.getFirstChild();
		String value = "";
		
		while(Property.getNodeName() != "ID" && Property.getNextSibling() != null) {
			Property = Property.getNextSibling();
		}
		
		value = Property.getFirstChild().getNodeValue();
		return value;
	}

	public String getTitle(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Property = node.getFirstChild();
		String value = "";
		
		while(Property.getNodeName() != "Title" && Property.getNextSibling() != null) {
			Property = Property.getNextSibling();
		}
		
		value = Property.getFirstChild().getNodeValue();
		return value;
	}
	
	public String getDescription(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Property = node.getFirstChild();
		String value = "";
		
		while(Property.getNodeName() != "Description" && Property.getNextSibling() != null) {
			Property = Property.getNextSibling();
		}
		if (Property.getFirstChild() != null){
			value = Property.getFirstChild().getNodeValue();
		}
		return value;
	}
	
	public String getSafeTitle(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Property = node.getFirstChild();
		String value = "";
		
		while(Property.getNodeName() != "Title" && Property.getNextSibling() != null) {
			Property = Property.getNextSibling();
		}
		
		value = Property.getFirstChild().getNodeValue();
//		value = value.replaceAll( "[<>:\"/\\|?]", "");
		value = value.replaceAll( "[^a-zA-Z0-9$()#_'`~@{}%! &-]", "");
		value = value.toLowerCase();
		return value;
	}
	
	public long getProductionYear(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Property = node.getFirstChild();
		String value = "";
		DateFormat df = new SimpleDateFormat("yyyy");
		DateFormat toMS = new SimpleDateFormat("S");
		Date ret = null;
		
		while(Property.getNodeName() != "ProductionYear" && Property.getNextSibling() != null) {
			Property = Property.getNextSibling();
		}
		
		value = Property.getFirstChild().getNodeValue();
		try {
			ret = df.parse(value);
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return ret.getTime();
	}
	
	public long getReleased(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Property = node.getFirstChild();
		String value = "";
		DateFormat df = new SimpleDateFormat("yyyy-MM-dd");
		Date ret = null;
		
		while(Property.getNodeName() != "Released" && Property.getNextSibling() != null) {
			Property = Property.getNextSibling();
		}
		
		value = Property.getFirstChild().getNodeValue();
		try {
			ret = df.parse(value);
		} catch (ParseException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return ret.getTime();
	}
	
	public Vector getGenres(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Property = node.getFirstChild();
		Vector value = new Vector();
		boolean found = false;
		
		while(Property.getNodeName() != "Genres" && Property.getNextSibling() != null) {
			Property = Property.getNextSibling();
		}
		Property = Property.getFirstChild();
		while(Property.getNextSibling() != null && !found){
			Property = Property.getNextSibling();
			if(Property.getFirstChild() != null && Property.getNodeName() == "Genre"){
				value.add(Property.getFirstChild().getNodeValue());
				//found = true;
			}
		}
		return value;
	}
	
	public Vector getAudio(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Property = node.getFirstChild();
		Node AudioFormat;
		Node Param;
		String actorName = "";
		Vector value = new Vector();
		int i = 0;
		
		while(Property.getNodeName() != "Audio" && Property.getNextSibling() != null) {
			Property = Property.getNextSibling();
		}
		AudioFormat = Property.getFirstChild();
		while(AudioFormat.getNextSibling() != null){
			AudioFormat = AudioFormat.getNextSibling();
			if(AudioFormat.getFirstChild() != null 
					&& AudioFormat.getNodeName() == "AudioFormat"){
				Param = AudioFormat.getFirstChild();
				while(Param.getNextSibling() != null){
					Param = Param.getNextSibling();
					if(Param.getFirstChild() != null 
							&& (Param.getNodeName() == "AudioLanguage" 
							|| Param.getNodeName() == "AudioCompression"
							|| Param.getNodeName() == "AudioChannels")){
						actorName = actorName + Param.getFirstChild().getNodeValue() + " ";
					}
				}
				value.add(actorName);
				actorName = "";
			}
		}
				
		return value;
	}
	
	public String getAR(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Property = node.getFirstChild();
		String value = "";
		
		while(Property.getNodeName() != "Format" && Property.getNextSibling() != null) {//AR info is child of Format
			Property = Property.getNextSibling();
		}
		Property = Property.getFirstChild();
		while(Property.getNextSibling() != null){
			Property = Property.getNextSibling();
			if(Property.getFirstChild() != null 
					&& Property.getNodeName() == "FormatAspectRatio"){
				value = value + Property.getFirstChild().getNodeValue();
			}
		}
		return value;
	}
	
	public boolean isLetterbox(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Property = node.getFirstChild();
		boolean isLetterbox = false;
		String value = "";
		
		while(Property.getNodeName() != "Format" && Property.getNextSibling() != null) {//AR info is child of Format
			Property = Property.getNextSibling();
		}
		Property = Property.getFirstChild();
		while(Property.getNextSibling() != null){
			Property = Property.getNextSibling();
			if(Property.getFirstChild() != null 
					&& Property.getNodeName() == "FormatLetterBox"){
				value = Property.getFirstChild().getNodeValue();
			}
		}
		
		if(value.compareToIgnoreCase("True") == 0){
			isLetterbox = true;
		}
		return isLetterbox;
	}
	
	public boolean isAnamorphic(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Property = node.getFirstChild();
		String value = "";
		boolean isAnamorphic = false;
		
		while(Property.getNodeName() != "Format" && Property.getNextSibling() != null) {//AR info is child of Format
			Property = Property.getNextSibling();
		}
		Property = Property.getFirstChild();
		while(Property.getNextSibling() != null){
			Property = Property.getNextSibling();
			if(Property.getFirstChild() != null 
					&& Property.getNodeName() == "Format16X9"){
				value = Property.getFirstChild().getNodeValue();
			}
		}
		if(value.compareToIgnoreCase("True") == 0){
			isAnamorphic = true;
		}
		
		return isAnamorphic;
	}
	
	public Vector getStudios(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Property = node.getFirstChild();
		Vector value = new Vector();
		
		while(Property.getNodeName() != "Studios" && Property.getNextSibling() != null) {
			Property = Property.getNextSibling();
		}
		Property = Property.getFirstChild();
		while(Property.getNextSibling() != null){
			Property = Property.getNextSibling();
			if(Property.getFirstChild() != null && Property.getNodeName() == "Studio"){
				value.add(Property.getFirstChild().getNodeValue());
			}
		}
		return value;
	}
	
	public Vector getDirectors(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Director = findNode(node, "Credits");
		Node Name;
		String name = "";
		Vector value = new Vector();
		Director = Director.getFirstChild();
		while(Director.getNextSibling() != null){
			Director = Director.getNextSibling();
			if(Director.getFirstChild() != null 
					&& Director.getNodeName() == "Credit"){
				Name = Director.getFirstChild();
				while(Name.getNextSibling() != null){
					Name = Name.getNextSibling();
					if(Name.getFirstChild() != null 
							&& (Name.getNodeName() == "FirstName" 
							|| Name.getNodeName() == "MiddleName"
							|| Name.getNodeName() == "LastName")){
						name = name + Name.getFirstChild().getNodeValue() + " ";
					}	
				}
				value.add(name);
				name = "";
			}
		}
		return value;
	}
	
	public Node findNode(Node node, String tag){
		NodeList nodes = node.getChildNodes();
		int i = 0;
		for(i = 0; nodes.item(i) != null && nodes.item(i).getNodeName() != tag; i++)
		{
			//nothing here
		}
		return nodes.item(i);
	}
	
	public Vector getActors(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Property = node.getFirstChild();
		Node Actor;
		Node Name;
		String actorName = "";
		Vector value = new Vector();
		int i = 0;
		
		while(Property.getNodeName() != "Actors" && Property.getNextSibling() != null) {
			Property = Property.getNextSibling();
		}
		Actor = Property.getFirstChild();
		while(Actor.getNextSibling() != null){
			Actor = Actor.getNextSibling();
			if(Actor.getFirstChild() != null 
					&& Actor.getNodeName() == "Actor"){
				Name = Actor.getFirstChild();
				while(Name.getNextSibling() != null){
					Name = Name.getNextSibling();
					if(Name.getFirstChild() != null 
							&& (Name.getNodeName() == "FirstName" 
							|| Name.getNodeName() == "MiddleName"
							|| Name.getNodeName() == "LastName")){
						actorName = actorName + Name.getFirstChild().getNodeValue() + " ";
					}
				}
				value.add(actorName);
				actorName = "";
				
				
			}
		}
				
		return value;
	}
	
	public Vector getRoles(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Property = node.getFirstChild();
		Node Actor;
		Node Name;
		String role = "";
		Vector value = new Vector();
		int i = 0;
		
		while(Property.getNodeName() != "Actors" && Property.getNextSibling() != null) {
			Property = Property.getNextSibling();
		}
		Actor = Property.getFirstChild();
		while(Actor.getNextSibling() != null){
			Actor = Actor.getNextSibling();
			if(Actor.getFirstChild() != null 
					&& Actor.getNodeName() == "Actor"){
				Name = Actor.getFirstChild();
				while(Name.getNextSibling() != null){
					Name = Name.getNextSibling();
					if(Name.getFirstChild() != null 
							&& (Name.getNodeName() == "Role")){
						role = role + Name.getFirstChild().getNodeValue() + " ";
					}
				}
				value.add(role);
				role = "";
				
				
			}
		}
				
		return value;
	}
	
	public String getOverview(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Property = node.getFirstChild();
		String value = "";
		
		while(Property.getNodeName() != "Overview" && Property.getNextSibling() != null) {
			Property = Property.getNextSibling();
		}
		if(Property.getFirstChild() != null){
			value = Property.getFirstChild().getNodeValue();
		}
		return value;
	}
	
	public long getDuration(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Property = node.getFirstChild();
		String value = "";
		long Duration = 0;
		
		while(Property.getNodeName() != "RunningTime" && Property.getNextSibling() != null) {
			Property = Property.getNextSibling();
		}
		if(Property.getFirstChild() != null){
			value = Property.getFirstChild().getNodeValue();
		}
		Duration = Integer.parseInt(value);
		//minutes * 60 * 1000 = msec
		Duration = Duration*60*1000;
		return Duration;
	}
	
	public String getRated(int n){
		Node node = DVDs.item(n);
		node.normalize();
		Node Property = node.getFirstChild();
		String value = "";
		
		while(Property.getNodeName() != "Rating" && Property.getNextSibling() != null) {
			Property = Property.getNextSibling();
		}
		if(Property.getFirstChild() != null){
			value = Property.getFirstChild().getNodeValue();
		}
		return value;
	}
	
	public void copyImage(String from, String to) throws IOException
	{
		File inputFile = new File(from);
		File outputFile = new File(to);
		if(inputFile.canRead())
		{
			FileInputStream in = new FileInputStream(inputFile);
	        FileOutputStream out = new FileOutputStream(outputFile);
	        byte[] buf = new byte[65536];
	        int c;

	        while ((c = in.read(buf)) > 0)
	           out.write(buf, 0, c);

	        in.close();
		    out.close();
		}
		
	}
	
	static final String typeName[] = {
			"none",
			"Collection",
			"DVD",
			"ID",
			"UPC",
			"Title",
			"SortTitle",
			"Regions",
			"Region",
			"CollectionType",
			"CollectionNumber",
			"WishPriority",
			"Rating",
			"ProductionYear",
			"Released",
			"RunningTime",
			"CaseType",
			"Genres",
			"Genre",
			"Format",
			"FormatAspectRatio",
			"FormatVideoStandar",
			"FormatLetterbox",
			"FormatPanAndScan",
			"FormatFullFrame",
			"Format16X9",
			"FormatDualSided",
			"FormatDualLayered",
			"FormatFlipper",
			"Features",
			"FeatureSceneAccess",
			"FeatureCommentary",
			"FeatureTrailer",
			"FeatureDeletedScenes",
			"FeatureMakingOf",
			"FeatureProductionNotes",
			"FeatureGame",
			"FeatureDVDROM",
			"FeatureMultiAngle",
			"FeatureMusicVideo",
			"FeatureClosedCaption",
			"FeatureTHXCertified",
			"Studios",
			"Studio",
			"Audio",
			"AudioFormat",
			"AudioLanguage",
			"AudioCompression",
			"AudioChannels",
			"Subtitles",
			"Subtitle",
			"Directors",
			"Director",
			"Actors",
			"Actor",
			"FirstName",
			"MiddleName",
			"LastName",
			"Role",
			"Review",
			"ReviewFilm",
			"ReviewVideo",
			"ReviewAudio",
			"ReviewExtras",
			"SRPInfo",
			"SRP",
			"SRPCurrencyID",
			"SRPCurrencyName",
			"PurchaseInfo",
			"PurchasePriceInfo",
			"PurchasePrice",
			"PurchasePriceCurrencyID",
			"PurchasePriceCurrencyName",
			"PurchaseDate",
			"PurchasePlace",
			"PurchacePlaceType",
			"PurchasePlaceWebsite",
			"LoanInfo",
			"Overview",
			"EasterEggs",
			"LastEdited"
	};
	
	
}
